commit 29c2ef53acae5c374b23322e860b5c1f6f5a92b6
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Mon Jul 29 23:47:57 2024 +0530

    PS-9301 LOCK_ORDER: CONNECTION_CONTROL PLUGIN INSTRUMENTATION IS NOT DISCOVERABLE
    
    https://perconadev.atlassian.net/browse/PS-9301
    
    Bug#29539976 mysql/mysql-server@131035749d9
    
    Before this fix:
    
    After loading the connection_control plugin,
    the performance schema instrumentation embedded in the code
    was not visible in table performance_schema.setup_instrument.
    
    This is a problem because available instruments are harder to discover:
    the workload has to execute a specific code path for the instrument
    to be eventually added in the performance schema.
    
    In this case, a connection had to actually be blocked
    by the connection control plugin for the mutex and cond to appear.
    
    This problem in particular affects the LOCK_ORDER tool,
    which failed to find the instrumentation in the
    connection control plugin.
    
    Root cause:
    
    PSI_server->register_mutex() was not called on plugin init
    but later during the plugin execution.
    
    Fix:
    
    The performance schema instrumentation
    for the connection_control plugin
    was reviewed in details, leading to the discovery
    and fix for the following issues:
    
    1) Mutexes, rwlocks and conditions were not registered up front
       on plugin init, but later.
       For mutexes and conds, the registration was executed
       multiple times, which is un necessary.
       For rwlocks, the registration was correct (done once and always),
       but the code pattern was inconsistent with instrumentation in general.
    
       All items are now registered once at plugin init.
    
    2) A stage was defined, but never registered,
       so that the performance schema was just ignoring it,
       treating the stage as un instrumented.
    
       The stage is now instrumented properly.

diff --git a/mysql-test/suite/connection_control/r/connection_delay_info_schema_view.result b/mysql-test/suite/connection_control/r/connection_delay_info_schema_view.result
index d90034ac466..a0681e3c9a5 100644
--- a/mysql-test/suite/connection_control/r/connection_delay_info_schema_view.result
+++ b/mysql-test/suite/connection_control/r/connection_delay_info_schema_view.result
@@ -6,6 +6,16 @@
 # Install connection_control plugin
 INSTALL PLUGIN connection_control SONAME 'CONNECTION_CONTROL_LIB';
 INSTALL PLUGIN connection_control_failed_login_attempts SONAME 'CONNECTION_CONTROL_LIB';
+# Performance schema
+# Verify the instrumentation provided
+SELECT * FROM performance_schema.setup_instruments
+WHERE NAME LIKE "%/conn_delay/%"
+  ORDER BY NAME;
+NAME	ENABLED	TIMED
+stage/conn_delay/Waiting in connection_control plugin	YES	YES
+wait/synch/cond/conn_delay/connection_delay_wait_condition	YES	YES
+wait/synch/mutex/conn_delay/connection_delay_mutex	YES	YES
+wait/synch/rwlock/conn_delay/connection_event_delay_lock	YES	YES
 # Create user accounts for testing
 CREATE USER u1@localhost IDENTIFIED BY 'abcd';
 CREATE USER u2@localhost IDENTIFIED BY 'abcd';
diff --git a/mysql-test/suite/connection_control/t/connection_delay_info_schema_view.test b/mysql-test/suite/connection_control/t/connection_delay_info_schema_view.test
index 0f8c3f98702..e2e7c01daaf 100644
--- a/mysql-test/suite/connection_control/t/connection_delay_info_schema_view.test
+++ b/mysql-test/suite/connection_control/t/connection_delay_info_schema_view.test
@@ -17,6 +17,13 @@
 --echo # Install connection_control plugin
 --source ../inc/install_connection_control_plugin.inc
 
+--echo # Performance schema
+--echo # Verify the instrumentation provided
+
+SELECT * FROM performance_schema.setup_instruments
+  WHERE NAME LIKE "%/conn_delay/%"
+  ORDER BY NAME;
+
 --echo # Create user accounts for testing
 CREATE USER u1@localhost IDENTIFIED BY 'abcd';
 CREATE USER u2@localhost IDENTIFIED BY 'abcd';
diff --git a/plugin/connection_control/connection_control.cc b/plugin/connection_control/connection_control.cc
index 9eed902ad8f..bf704515bea 100644
--- a/plugin/connection_control/connection_control.cc
+++ b/plugin/connection_control/connection_control.cc
@@ -63,6 +63,57 @@ Connection_event_coordinator *g_connection_event_coordinator= 0;
 MYSQL_PLUGIN connection_control_plugin_info= 0;
 
 
+/* Performance Schema instrumentation */
+
+PSI_mutex_key key_connection_delay_mutex = PSI_NOT_INSTRUMENTED;
+
+static PSI_mutex_info all_connection_delay_mutex_info[]=
+{
+  {&key_connection_delay_mutex, "connection_delay_mutex", 0}
+};
+
+PSI_rwlock_key key_connection_event_delay_lock;
+
+static PSI_rwlock_info all_connection_delay_rwlock_info[]=
+{
+  {&key_connection_event_delay_lock, "connection_event_delay_lock", 0}
+};
+
+PSI_cond_key key_connection_delay_wait = PSI_NOT_INSTRUMENTED;
+
+static PSI_cond_info all_connection_delay_cond_info[]=
+{
+  {&key_connection_delay_wait, "connection_delay_wait_condition", 0}
+};
+
+PSI_stage_info stage_waiting_in_connection_control_plugin=
+{0, "Waiting in connection_control plugin", 0};
+
+static PSI_stage_info *all_connection_delay_stage_info[]=
+{&stage_waiting_in_connection_control_plugin};
+
+
+/** Register all performance schema instrumentation for connection_control */
+static void
+init_performance_schema()
+{
+  const char *category = "conn_delay";
+
+  int count_mutex = array_elements(all_connection_delay_mutex_info);
+  PSI_server->register_mutex(category, all_connection_delay_mutex_info, count_mutex);
+
+  int count_rwlock = array_elements(all_connection_delay_rwlock_info);
+  mysql_rwlock_register(category, all_connection_delay_rwlock_info,
+                        count_rwlock);
+
+  int count_cond = array_elements(all_connection_delay_cond_info);
+  PSI_server->register_cond(category, all_connection_delay_cond_info, count_cond);
+
+  int count_stage = array_elements(all_connection_delay_stage_info);
+  mysql_stage_register(category, all_connection_delay_stage_info, count_stage);
+}
+
+
 /**
   event_notify() implementation for connection_control
 
@@ -115,6 +166,13 @@ connection_control_notify(MYSQL_THD thd,
 static int
 connection_control_init(MYSQL_PLUGIN plugin_info)
 {
+
+  /*
+    Declare all performance schema instrumentation up front,
+    so it is discoverable.
+  */
+  init_performance_schema();
+
   connection_control_plugin_info= plugin_info;
   Connection_control_error_handler error_handler(connection_control_plugin_info);
   g_connection_event_coordinator= new Connection_event_coordinator();
diff --git a/plugin/connection_control/connection_control.h b/plugin/connection_control/connection_control.h
index 471cedc3d33..a9c12352c4f 100644
--- a/plugin/connection_control/connection_control.h
+++ b/plugin/connection_control/connection_control.h
@@ -23,10 +23,16 @@
 #ifndef CONNECTION_CONTROL_H
 #define CONNECTION_CONTROL_H
 
+#include <mysql/psi/mysql_stage.h>
 #include <mysql/psi/mysql_thread.h>     /* mysql_rwlock_t */
 
 #include "connection_control_data.h"
 
+extern PSI_mutex_key key_connection_delay_mutex;
+extern PSI_rwlock_key key_connection_event_delay_lock;
+extern PSI_cond_key key_connection_delay_wait;
+extern PSI_stage_info stage_waiting_in_connection_control_plugin;
+
 namespace connection_control
 {
 
diff --git a/plugin/connection_control/connection_delay.cc b/plugin/connection_control/connection_delay.cc
index 4b920b1967d..cbc6421a53d 100644
--- a/plugin/connection_control/connection_delay.cc
+++ b/plugin/connection_control/connection_delay.cc
@@ -73,11 +73,6 @@ namespace connection_control
 
   /** variables used by connection_delay.cc */
   static mysql_rwlock_t connection_event_delay_lock;
-  static PSI_rwlock_key key_connection_event_delay_lock;
-  static PSI_rwlock_info all_rwlocks[]=
-  {
-    {&key_connection_event_delay_lock, "connection_event_delay_lock", 0}
-  };
 
   static opt_connection_control opt_enums[]=
   {
@@ -542,31 +537,14 @@ namespace connection_control
 
     /** PSI_stage_info for thd_enter_cond/thd_exit_cond */
     PSI_stage_info old_stage;
-    PSI_stage_info stage_waiting_in_connection_control_plugin=
-    {0, "Waiting in connection_control plugin", 0};
 
     /** Initialize mutex required for mysql_cond_timedwait */
     mysql_mutex_t connection_delay_mutex;
-    const char * category= "conn_delay";
-    PSI_mutex_key key_connection_delay_mutex;
-    PSI_mutex_info connection_delay_mutex_info[]=
-    {
-      {&key_connection_delay_mutex, "connection_delay_mutex", PSI_FLAG_GLOBAL}
-    };
-    int count_mutex= array_elements(connection_delay_mutex_info);
-    PSI_server->register_mutex(category, connection_delay_mutex_info, count_mutex);
     mysql_mutex_init(key_connection_delay_mutex, &connection_delay_mutex,
                      MY_MUTEX_INIT_FAST);
 
     /* Initialize condition to wait for */
     mysql_cond_t connection_delay_wait_condition;
-    PSI_cond_key key_connection_delay_wait;
-    PSI_cond_info connection_delay_wait_info[]=
-    {
-      {&key_connection_delay_wait, "connection_delay_wait_condition", 0}
-    };
-    int count_cond= array_elements(connection_delay_wait_info);
-    PSI_server->register_cond(category, connection_delay_wait_info, count_cond);
     mysql_cond_init(key_connection_delay_wait, &connection_delay_wait_condition);
 
     /** Register wait condition with THD */
@@ -927,9 +905,6 @@ namespace connection_control
     /*
       1. Initialize lock(s)
     */
-    const char *category= "conn_control";
-    int count= array_elements(all_rwlocks);
-    mysql_rwlock_register(category, all_rwlocks, count);
     mysql_rwlock_init(key_connection_event_delay_lock,
                       &connection_event_delay_lock);
     g_max_failed_connection_handler= new Connection_delay_action(g_variables.failed_connections_threshold,

